//+------------------------------------------------------------------+

//|                                                       EMA 1R.mq5 |

//|                                                       RRLaishram |

//|                                             https://www.mql5.com |

//+------------------------------------------------------------------+

#property copyright "RRLaishram"
#property link      "https://www.mql5.com"
#property version   "1.00"
#include  <Trade\Trade.mqh>
//Global Initializations
double FastEmaArray[], SlowEmaArray[], MidEmaArray[];
double EntryEma[], StopLossEma[];
int FastEmaHandle,SlowEmaHandle,MidEmaHandle;
int EntryHandle, StopLossHandle;
double FastEmaValue, MidEmaValue, SlowEmaValue;
double EntryValue, StopLossValue;
int MAGICNUMBER = 9991;
string ConditionRest = "true";
double high, low;
string reset = "true";
int reward = 2;
ulong Deviation = 10;
CTrade Trade;
int OnInit()
  {
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

   FastEmaHandle = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_EMA,PRICE_CLOSE);

   MidEmaHandle = iMA(_Symbol,PERIOD_CURRENT,20,0,MODE_EMA,PRICE_CLOSE);

   SlowEmaHandle = iMA(_Symbol,PERIOD_CURRENT,40,0,MODE_EMA,PRICE_CLOSE);

   EntryHandle = iMA(_Symbol,PERIOD_CURRENT,7,0,MODE_EMA,PRICE_CLOSE);

   StopLossHandle = iMA(_Symbol,PERIOD_CURRENT,45,0,MODE_EMA,PRICE_CLOSE);

   ArraySetAsSeries(FastEmaArray,true);

   ArraySetAsSeries(MidEmaArray,true);

   ArraySetAsSeries(SlowEmaArray,true);

   ArraySetAsSeries(EntryEma,true);

   ArraySetAsSeries(StopLossEma,true);

   CopyBuffer(FastEmaHandle,0,0,3,FastEmaArray);

   CopyBuffer(MidEmaHandle,0,0,3,MidEmaArray);

   CopyBuffer(SlowEmaHandle,0,0,3,SlowEmaArray);

   CopyBuffer(EntryHandle,0,0,3,EntryEma);

   CopyBuffer(StopLossHandle,0,0,3,StopLossEma);

   FastEmaValue = NormalizeDouble(FastEmaArray[0],_Digits);

   MidEmaValue = NormalizeDouble(MidEmaArray[0],_Digits);

   SlowEmaValue = NormalizeDouble(SlowEmaArray[0],_Digits);

   EntryValue = NormalizeDouble(EntryEma[0],_Digits);

   StopLossValue = NormalizeDouble(StopLossEma[0],_Digits);

//Comment("Fast : ",FastEmaValue, " Mid  :  ", MidEmaValue, " Slow  :  ", SlowEmaValue);

   high = NormalizeDouble(iHigh(_Symbol,PERIOD_CURRENT,1),_Digits);

   low = NormalizeDouble(iLow(_Symbol,PERIOD_CURRENT,1),_Digits);

//Alert ("Reset Condition  : ", reset);

   if(reset == "true")

     {

      EmaCondition();

      // Alert ("Reset Condition  : ", reset);

     }

// reset market

   if(FastEmaValue < MidEmaValue && MidEmaValue > SlowEmaValue)

     {

      reset = "true";

     }

   if(FastEmaValue > MidEmaValue && MidEmaValue < SlowEmaValue)

     {

      reset = "true";

     }

  }

void EmaCondition()

  {

   Comment("Fast : ",FastEmaValue, " Mid  :  ", MidEmaValue, " Slow  :  ", SlowEmaValue);

   if(FastEmaValue > MidEmaValue && MidEmaValue > SlowEmaValue)

     {

      //Alert("Ema Value Satisfied");

      if(high > FastEmaValue && low > FastEmaValue)

        {

         // if (MathAbs(FastEmaValue - SlowEmaValue) >=(10 * _Point) && MathAbs(FastEmaValue - SlowEmaValue) <= (40 * _Point))

         // Buy COndition

         Comment("Buy Condition Satisfied");

         //Alert (5 * _Point);

           {

            double TakeProfit = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits) + reward * (MathAbs(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits) - StopLossValue));

            if(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits) < EntryValue)

              {

               Trade.SetDeviationInPoints(Deviation);

               Trade.SetExpertMagicNumber(MAGICNUMBER);

               if(Trade.Buy(0.01,_Symbol,NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits),StopLossValue,TakeProfit))

                 {

                  reset = "fasle";

                 }

               else

                 {

                  reset = "fasle";

                 }

              }

           }

        }

     }



   if(FastEmaValue < MidEmaValue && MidEmaValue < SlowEmaValue)

     {

      if(high < FastEmaValue && low < FastEmaValue)

        {

         // Sell Condition

         Comment("Sell Condition Satisfied");

         // if (MathAbs(FastEmaValue - SlowEmaValue) >=(30 * _Point) && MathAbs(FastEmaValue - SlowEmaValue) <= (100 * _Point))



           {

            double TakeProfit1 = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits) - reward * MathAbs(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits) - StopLossValue);

            if(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits) > (EntryValue))

              {

               Trade.SetDeviationInPoints(Deviation);

               Trade.SetExpertMagicNumber(MAGICNUMBER);

               Alert(StopLossValue,"   ",TakeProfit1);

               if(Trade.Sell(0.01,_Symbol,NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits),StopLossValue,TakeProfit1))

                 {

                  reset = "fasle";

                 }

               else

                 {

                  reset = "fasle";

                 }

              }

           }

        }

     }

  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
